#!bin/csh
# rm -rf *.temp
# csh cdfs.com 1 packets 100Mb ps
# csh cdfs.com 2 packets 100Mb ps
# csh cdfs.com 3 packets 100Mb ps
# csh cdfs.com 4 packets 100Mb ps
# csh cdfs.com 1 packets 100Mb table
# csh cdfs.com 2 packets 100Mb table
# csh cdfs.com 3 packets 100Mb table
# csh cdfs.com 4 packets 100Mb table
# csh cdfs.com 1 packets 10Mb ps
# csh cdfs.com 2 packets 10Mb ps
# csh cdfs.com 3 packets 10Mb ps
# csh cdfs.com 4 packets 10Mb ps
# csh cdfs.com 1 packets 10Mb table
# csh cdfs.com 2 packets 10Mb table
# csh cdfs.com 3 packets 10Mb table
# csh cdfs.com 4 packets 10Mb table
# csh cdfs.com 1 bytes 100Mb ps
# csh cdfs.com 2 bytes 100Mb ps
# csh cdfs.com 3 bytes 100Mb ps
# csh cdfs.com 4 bytes 100Mb ps
# csh cdfs.com 1 bytes 100Mb table
# csh cdfs.com 2 bytes 100Mb table
# csh cdfs.com 3 bytes 100Mb table
# csh cdfs.com 4 bytes 100Mb table
# csh cdfs.com 1 bytes 10Mb ps
# csh cdfs.com 2 bytes 10Mb ps
# csh cdfs.com 3 bytes 10Mb ps
# csh cdfs.com 4 bytes 10Mb ps
# csh cdfs.com 1 bytes 10Mb table
# csh cdfs.com 2 bytes 10Mb table
# csh cdfs.com 3 bytes 10Mb table
# csh cdfs.com 4 bytes 10Mb table
set num = $1;
set queue = $2;
set link = $3;
set type = $4;
if ($queue == "bytes") then
  set bp = 1;
endif
if ($queue == "packets") then
  set bp = 0;
endif
if ($num == 1) then
  set file1 = "$link-util-0.95-ecn-syn-0-ecn-syn-wait-0-bytes-$bp.dat";
  set file2 = "$link-util-0.95-ecn-syn-1-ecn-syn-wait-0-bytes-$bp.dat";
  set file3 = "$link-util-0.95-ecn-syn-1-ecn-syn-wait-1-bytes-$bp.dat";
  set file4 = "$link-util-0.95-ecn-syn-1-ecn-syn-wait-2-bytes-$bp.dat";
  set load = 0.95;
endif  
if ($num == 2) then
  set file1 = "$link-util-1.1-ecn-syn-0-ecn-syn-wait-0-bytes-$bp.dat";
  set file2 = "$link-util-1.1-ecn-syn-1-ecn-syn-wait-0-bytes-$bp.dat";
  set file3 = "$link-util-1.1-ecn-syn-1-ecn-syn-wait-1-bytes-$bp.dat";
  set file4 = "$link-util-1.1-ecn-syn-1-ecn-syn-wait-2-bytes-$bp.dat";
  set load = 1.1;
endif  
if ($num == 3) then
  set file1 = "$link-util-1.25-ecn-syn-0-ecn-syn-wait-0-bytes-$bp.dat";
  set file2 = "$link-util-1.25-ecn-syn-1-ecn-syn-wait-0-bytes-$bp.dat";
  set file3 = "$link-util-1.25-ecn-syn-1-ecn-syn-wait-1-bytes-$bp.dat";
  set file4 = "$link-util-1.25-ecn-syn-1-ecn-syn-wait-2-bytes-$bp.dat";
  set load = 1.25;
endif  
if ($num == 4) then
  set file1 = "$link-util-1.5-ecn-syn-0-ecn-syn-wait-0-bytes-$bp.dat";
  set file2 = "$link-util-1.5-ecn-syn-1-ecn-syn-wait-0-bytes-$bp.dat";
  set file3 = "$link-util-1.5-ecn-syn-1-ecn-syn-wait-1-bytes-$bp.dat";
  set file4 = "$link-util-1.5-ecn-syn-1-ecn-syn-wait-2-bytes-$bp.dat";
  set load = 1.5;
endif  
if ($type == ps) then
  awk '{if (NR>2) {print;}}' $file1 > $file1.temp;
  awk '{if (NR>2) {print;}}' $file2 > $file2.temp;
  awk '{if (NR>2) {print;}}' $file3 > $file3.temp;
  awk '{if (NR>2) {print;}}' $file4 > $file4.temp;
endif
if ($type == table) then
  awk '{if (NR>2 && ($1==10 || ($1>=100 && $1<=500) || ($1>=1000 && ($1<=5000)))) {printf "%5.0f %5.2f\n", $1, $2;}}' $file1 > $file1.temp;
  awk '{if (NR>2 && ($1==10 || ($1>=100 && $1<=500) || ($1>=1000 && ($1<=5000)))) {printf "%5.0f %5.2f\n", $1, $2;}}' $file2 > $file2.temp;
  awk '{if (NR>2 && ($1==10 || ($1>=100 && $1<=500) || ($1>=1000 && ($1<=5000)))) {printf "%5.0f %5.2f\n", $1, $2;}}' $file3 > $file3.temp;
  awk '{if (NR>2 && ($1==10 || ($1>=100 && $1<=500) || ($1>=1000 && ($1<=5000)))) {printf "%5.0f %5.2f\n", $1, $2;}}' $file4 > $file4.temp;
endif
if ($type == ps) then
gnuplot << !
set terminal postscript eps
set xlabel "Time (in ms)"
set ylabel "CDF"
set title "CDF, $link, load $load, queue in $queue"
set output "CDF-$link-$load-$queue.ps"
set key right bottom 
# set size 0.6,0.8
set size 1.0,0.8 
plot "$file1.temp" title "ECN" with lines, "$file2.temp" title "ECN+" with lines, "$file3.temp" title "ECN+/Wait" with lines, "$file4.temp" title "ECN+/TryOnce" with lines
!
endif
if ($type == table) then
  echo "TIME:    10  100  200  300  400  500 1000 2000 3000 4000 5000";
  echo "       ------------------------------------------------------";
  awk 'BEGIN{printf "%5s", "ECN:  ";}{printf "%5.2f", $2}END{printf "\n";}' $file1.temp;
  awk 'BEGIN{printf "%5s", "ECN+: ";}{printf "%5.2f", $2}END{printf "\n";}' $file2.temp;
  awk 'BEGIN{printf "%5s", "Wait: ";}{printf "%5.2f", $2}END{printf "\n";}' $file3.temp;
  awk 'BEGIN{printf "%5s", "Once: ";}{printf "%5.2f", $2}END{printf "\n";}' $file4.temp;
endif
