# awk -f results.awk out.100Mb > out.100Mb.results
# awk -f results.awk out.braeburn > out.braeburn.results
# awk -f results1.awk out.100Mb.results
# awk -f results1.awk out.braeburn.results
# input:
#   dropped: 20516 marked: 28735 drop-rate: 1.41 thput: 0.81
# output:
#                      ECN        ECN+     ECN+/wait
#                   -------     -------     -------
#        Dropped      8,754       6,719       7,269
#        Marked      10,376      17,637      16,956
#        Loss rate    5.68%       4.50%       4.75%
#        Throughput     78%         78%         78%

{
if ($1~"0.95") {speed = 0.95;}
if ($1=="dropped:") {
  ++count;
  drops[count] = $2;
  marks[count] = $4;
  droprate[count] = $6;
  thput[count] = 100*$8;
}
if (count == 4 && ($1~"1.1" || $1~"1.25" || $1~"1.5" || $1~"END")) {
  count = 0;
  print " "
  printf "Target Load = %5.2f%%\n", speed;
  print "              ECN        ECN+     ECN+/Wait    ECN+/TryOnce"
  print "           -------     -------     -------      ----------"
  printf "Dropped     %7d    %7d    %7d    %7d\n", drops[1], drops[2], drops[3], drops[4];
  printf "Marked      %7d    %7d    %7d    %7d\n", marks[1], marks[2], marks[3], marks[4];
  printf "Loss rate     %5.1f%%      %5.1f%%      %5.1f%%     %5.1f%%\n", droprate[1], droprate[2], droprate[3], droprate[4];
  printf "Throughput    %5d%%      %5d%%      %5d%%      %5d%%\n", thput[1], thput[2], thput[3], thput[4];
  }
if (count == 1 && $1~"1.1") {speed = 1.1;}
if (count == 1 && $1~"1.25") {speed = 1.25;}
if (count == 1 && $1~"1.5") {speed = 1.5;}
}
