#!/usr/bin/perl
# To run: 
# ./test-packmime-delaybox-all.pl packets 10Mb table > out.packets.10Mb
# ./test-packmime-delaybox-all.pl bytes 10Mb table > out.bytes.10Mb
# ./test-packmime-delaybox-all.pl packets 100Mb table > out.packets.100Mb
# ./test-packmime-delaybox-all.pl bytes 100Mb table > out.bytes.100Mb

# bytes = 0 for a packet-based queue, bytes = 1 for a bytes-based queue.
$bytes = 0; 
if ($#ARGV >= 0) {
  $queue = "$ARGV[0]";
  ## print "$queue\n";
  if ($queue eq "packets") {$bytes = 0;} 
  elsif ($queue eq "bytes") {$bytes = 1;} 
}
if ($bytes=="0") {$units = "packets";}
elsif ($bytes=="1") {$units = "bytes";}

#$bandwidth = "10Mb";
$bandwidth = "100Mb";
if ($#ARGV >= 1) {
  ## print "$ARGV[1]\n";
  if ($ARGV[1] eq "10Mb") { $bandwidth = "10Mb";} 
  elsif ($ARGV[1] eq "100Mb") { $bandwidth = "100Mb";} 
}

$filename = "out.$units.$bandwidth";
print "filename: $filename\n";

$make_table = 0;
if ($#ARGV >= 2) {
  if ($ARGV[2] eq "table") {$make_table = 1;}
}

$duration = 75;
$warmup = 10; 
$make_trace = 0;
#$make_trace = 1;
$http_trace = 1;
$new_seed = 12345;
$rsp_size_avg = 3000;
#$rsp_size_avg = 7000;

foreach $util (0.95, 1.1, 1.25, 1.5) {
#foreach $util (1.5) {
  foreach $ecn_syn (0, 1) {
  #foreach $ecn_syn (1) {
      foreach $ecn_syn_wait (0, 1, 2) {
      #foreach $ecn_syn_wait (1) {
        if ($ecn_syn || !$ecn_syn_wait) {
           # don't run simulations for ecn-syn 0 and ecn-syn_wait 1
           if ($bandwidth == "10Mb") {$bps = 10000000;} 
           elsif ($bandwidth == "100Mb") {$bps = 100000000;} 
	   $rate = int(($util * $bps)/($rsp_size_avg*8));
	   $datadir = "$bandwidth-util-$util-ecn-syn-$ecn_syn-ecn-syn-wait-$ecn_syn_wait-bytes-$bytes"; 
		$cmd= "./ns test-packmime-delaybox-single.tcl " 
		.	"duration $duration "
		.	"warmup $warmup "
		.	"rate $rate "
		.	"tcptype Sack "
		.	"ecn-syn $ecn_syn "
		.	"ecn-syn-wait $ecn_syn_wait "
		.	"bytes	$bytes "
		.	"link-bw $bandwidth "
		.	"run 1 "
		.	"datadir $datadir "
		.	"new-seed $new_seed "
		.	"rsp-size-avg $rsp_size_avg "
                .       "http-trace $http_trace "
		.	"make-trace $make_trace ";
		
		print "$cmd\n";
		system($cmd);

                if ($make_trace) {
		    system("./getRate1.pl 11 $datadir/data-test-packmime-delaybox.trq >$datadir.dat");
		    system("./getPloss.pl 11 $datadir/data-test-packmime-delaybox.trq >>$datadir.dat");
		    #system("rm -rf $datadir/data-test-packmime-delaybox.trq");
                }
		
                if ($http_trace) {
		    system("cat $datadir/data-test-packmime-delaybox-*.dat > aggr.dat");
		    system("./getCDF0.pl aggr.dat >>$datadir.dat");
		    system("rm -rf aggr.dat");
                }
        }
      }
  }
}

if ($make_table) {
  $cmd = "awk -f results.awk $filename > $filename.results";
  print "$cmd\n"; system($cmd);
  $cmd = "echo END >> $filename.results";
  print "$cmd\n"; system($cmd);
  $cmd = "awk -f results1.awk $filename.results";
  print "$cmd\n"; system($cmd);
}

# $datadir/data-test-packmime-delaybox-*.dat:
# 10.049365   100        439        44.226     5.7893   283 

# $datadir/data-test-packmime-delaybox.trq: trace file

# $datadir.dat: 
#  If make_trace:  getRate1.pl, getPloss.pl, CDF
#  Else: CDF only
# getRate1.pl: offered load, throughput
# 84977564.8770442        84887492.9337795
# getPloss.pl: total_dropped, total_packets, loss rate
# 20516   1458208 0.0140693234435691

# 100 Mbps, packets:
# awk -f results.awk out.packets.100Mb > out.packets.100Mb.results
# echo "END" >> out.packets.100Mb.results
# awk -f results1.awk out.packets.100Mb.results

# 100 Mbps, bytes:
# awk -f results.awk out.bytes.100Mb > out.bytes.100Mb.results
# echo "END" >> out.bytes.100Mb.results
# awk -f results1.awk out.bytes.100Mb.results

# 10 Mbps, packets:
# awk -f results.awk out.packets.10Mb > out.packets.10Mb.results
# echo "END" >> out.packets.10Mb.results
# awk -f results1.awk out.packets.10Mb.results

# 10 Mbps, bytes:
# awk -f results.awk out.bytes.10Mb > out.bytes.10Mb.results
# echo "END" >> out.bytes.10Mb.results
# awk -f results1.awk out.bytes.10Mb.results

# results.awk output:
# dropped: 20516 marked: 28735 drop-rate: 1.41 thput: 0.81
# results1.awk output:
#                      ECN        ECN+     ECN+/wait
#                   -------     -------     -------
#        Dropped      8,754       6,719       7,269
#        Marked      10,376      17,637      16,956
#        Loss rate    5.68%       4.50%       4.75%
#        Throughput     78%         78%         78%

# To print table of response times:
# csh cdfs.com 1 packets ps 
